package addBk.address;

import gui.run.RunButton;

import java.beans.PropertyEditor;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: dlyon
 * Date: Feb 23, 2005
 * Time: 8:28:54 PM
 * Copyright DocJava, 2005
 */
public class AddressRecordEditor implements PropertyEditor {
    private AddressRecord ar = new AddressRecord();
    PropertyChangeSupport pcs = new PropertyChangeSupport(ar);
    public boolean isPaintable() {
        return false;
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
        return new RunButton("..."){
            public void run(){
                setValue(promptUserForAddressRecord());
            }
        };
    }
    //todo: get a record from a custom editor
    //Hint: a modal dialog might be good for this.
    private AddressRecord promptUserForAddressRecord() {
        return null;
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        pcs.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        pcs.removePropertyChangeListener(listener);

    }

    public Object getValue() {
        return ar;
    }

    public void setValue(Object newValue) {
        AddressRecord newRecord = (AddressRecord)newValue;
        if (ar.equals(newRecord)) return;
        pcs.firePropertyChange("AddressRecord",ar,newValue);
        ar = newRecord;
    }
   // todo: implement a CSV output for the getter.
    public String getAsText() {
        return ar.toString();
    }

    public String getJavaInitializationString() {
        return null;
    }

    public String[] getTags() {
        return new String[0];
    }
    // todo: implement a CSV input for the
    // setter.
    public void setAsText(String text) throws IllegalArgumentException {
    }

    public void paintValue(Graphics gfx, Rectangle box) {
    }
}
